﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;

namespace Usando_Threads
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }

        delegate void SetTextCallback(string texto);

        private void btnThreadSegura_Click(object sender, EventArgs e)
        {
            Thread th = new Thread(new ThreadStart(this.Thread_Segura));
            th.Start();
            txtTexto.Text = "Texto inserido pela Thread Principal.";
        }

        private void Thread_Segura()
        {
            Thread.Sleep(2000);
            string texto = "Texto Escrito de forma não segura pela Thread em segundo plano.";
            if (this.txtTexto.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(DefinirTexto);
                this.Invoke(d, new object[] { texto + " (Invoke)" });
            }
            else
            {
                this.txtTexto.Text = texto + " (No Invoke)";
            }
        }

        private void DefinirTexto(string texto)
        {
            this.txtTexto.Text = texto;
        }
    }
}
